// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dataspeed_dbw_msgs:msg/MiscCmd.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_MSGS__MSG__DETAIL__MISC_CMD__TRAITS_HPP_
#define DATASPEED_DBW_MSGS__MSG__DETAIL__MISC_CMD__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dataspeed_dbw_msgs/msg/detail/misc_cmd__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'cmd'
#include "dataspeed_dbw_msgs/msg/detail/turn_signal__traits.hpp"

namespace dataspeed_dbw_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MiscCmd & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: cmd
  {
    out << "cmd: ";
    to_flow_style_yaml(msg.cmd, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MiscCmd & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: cmd
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd:\n";
    to_block_style_yaml(msg.cmd, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MiscCmd & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dataspeed_dbw_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dataspeed_dbw_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dataspeed_dbw_msgs::msg::MiscCmd & msg,
  std::ostream & out, size_t indentation = 0)
{
  dataspeed_dbw_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dataspeed_dbw_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dataspeed_dbw_msgs::msg::MiscCmd & msg)
{
  return dataspeed_dbw_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dataspeed_dbw_msgs::msg::MiscCmd>()
{
  return "dataspeed_dbw_msgs::msg::MiscCmd";
}

template<>
inline const char * name<dataspeed_dbw_msgs::msg::MiscCmd>()
{
  return "dataspeed_dbw_msgs/msg/MiscCmd";
}

template<>
struct has_fixed_size<dataspeed_dbw_msgs::msg::MiscCmd>
  : std::integral_constant<bool, has_fixed_size<dataspeed_dbw_msgs::msg::TurnSignal>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dataspeed_dbw_msgs::msg::MiscCmd>
  : std::integral_constant<bool, has_bounded_size<dataspeed_dbw_msgs::msg::TurnSignal>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dataspeed_dbw_msgs::msg::MiscCmd>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DATASPEED_DBW_MSGS__MSG__DETAIL__MISC_CMD__TRAITS_HPP_
