// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dataspeed_dbw_msgs:msg/GearReject.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_MSGS__MSG__DETAIL__GEAR_REJECT__STRUCT_H_
#define DATASPEED_DBW_MSGS__MSG__DETAIL__GEAR_REJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NONE'.
/**
  * Not rejected
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__NONE = 0
};

/// Constant 'SHIFT_IN_PROGRESS'.
/**
  * Shift in progress
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__SHIFT_IN_PROGRESS = 1
};

/// Constant 'OVERRIDE'.
/**
  * Override on brake, throttle, or steering
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__OVERRIDE = 2
};

/// Constant 'NEUTRAL'.
/**
  * Manually shift to neutral before auto-shift
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__NEUTRAL = 3
};

/// Constant 'PARK'.
/**
  * Can't shift out of Park (Polaris 4)
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__PARK = 4
};

/// Constant 'VEHICLE'.
/**
  * Rejected by vehicle (try pressing the brakes)
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__VEHICLE = 5
};

/// Constant 'UNSUPPORTED'.
/**
  * Unsupported gear command
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__UNSUPPORTED = 6
};

/// Constant 'FAULT'.
/**
  * System in fault state
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__FAULT = 7
};

/// Constant 'LOW'.
/**
  * Can't shift to Low (Polaris 3)
 */
enum
{
  dataspeed_dbw_msgs__msg__GearReject__LOW = 8
};

/// Struct defined in msg/GearReject in the package dataspeed_dbw_msgs.
typedef struct dataspeed_dbw_msgs__msg__GearReject
{
  uint8_t value;
} dataspeed_dbw_msgs__msg__GearReject;

// Struct for a sequence of dataspeed_dbw_msgs__msg__GearReject.
typedef struct dataspeed_dbw_msgs__msg__GearReject__Sequence
{
  dataspeed_dbw_msgs__msg__GearReject * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dataspeed_dbw_msgs__msg__GearReject__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_DBW_MSGS__MSG__DETAIL__GEAR_REJECT__STRUCT_H_
