// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dataspeed_dbw_msgs:msg/SteeringCmd.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_
#define DATASPEED_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CMD_ANGLE'.
/**
  * Command types
 */
enum
{
  dataspeed_dbw_msgs__msg__SteeringCmd__CMD_ANGLE = 0
};

/// Constant 'CMD_TORQUE'.
enum
{
  dataspeed_dbw_msgs__msg__SteeringCmd__CMD_TORQUE = 1
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/SteeringCmd in the package dataspeed_dbw_msgs.
typedef struct dataspeed_dbw_msgs__msg__SteeringCmd
{
  std_msgs__msg__Header header;
  /// Steering Wheel
  /// rad, range -10.5 to 10.5
  float steering_wheel_angle_cmd;
  /// rad/s, range 0 to 17.5, 0 = default
  float steering_wheel_angle_velocity;
  /// Nm, range -60.0 to 60.0
  float steering_wheel_torque_cmd;
  uint8_t cmd_type;
  /// Enable
  bool enable;
  /// Clear driver overrides
  bool clear;
  /// Ignore driver overrides
  bool ignore;
  /// Sets current steering wheel angle to value in steering_wheel_angle_cmd
  bool calibrate;
  /// Disable or activate the driver override audible warning
  bool quiet;
  bool alert;
  /// Watchdog counter (optional)
  uint8_t count;
} dataspeed_dbw_msgs__msg__SteeringCmd;

// Struct for a sequence of dataspeed_dbw_msgs__msg__SteeringCmd.
typedef struct dataspeed_dbw_msgs__msg__SteeringCmd__Sequence
{
  dataspeed_dbw_msgs__msg__SteeringCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dataspeed_dbw_msgs__msg__SteeringCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_
