// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dataspeed_dbw_msgs:msg/ThrottleCmd.idl
// generated code does not contain a copyright notice
#include "dataspeed_dbw_msgs/msg/detail/throttle_cmd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
dataspeed_dbw_msgs__msg__ThrottleCmd__init(dataspeed_dbw_msgs__msg__ThrottleCmd * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dataspeed_dbw_msgs__msg__ThrottleCmd__fini(msg);
    return false;
  }
  // pedal_cmd
  // pedal_cmd_type
  // enable
  // clear
  // ignore
  // count
  return true;
}

void
dataspeed_dbw_msgs__msg__ThrottleCmd__fini(dataspeed_dbw_msgs__msg__ThrottleCmd * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // pedal_cmd
  // pedal_cmd_type
  // enable
  // clear
  // ignore
  // count
}

bool
dataspeed_dbw_msgs__msg__ThrottleCmd__are_equal(const dataspeed_dbw_msgs__msg__ThrottleCmd * lhs, const dataspeed_dbw_msgs__msg__ThrottleCmd * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // pedal_cmd
  if (lhs->pedal_cmd != rhs->pedal_cmd) {
    return false;
  }
  // pedal_cmd_type
  if (lhs->pedal_cmd_type != rhs->pedal_cmd_type) {
    return false;
  }
  // enable
  if (lhs->enable != rhs->enable) {
    return false;
  }
  // clear
  if (lhs->clear != rhs->clear) {
    return false;
  }
  // ignore
  if (lhs->ignore != rhs->ignore) {
    return false;
  }
  // count
  if (lhs->count != rhs->count) {
    return false;
  }
  return true;
}

bool
dataspeed_dbw_msgs__msg__ThrottleCmd__copy(
  const dataspeed_dbw_msgs__msg__ThrottleCmd * input,
  dataspeed_dbw_msgs__msg__ThrottleCmd * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // pedal_cmd
  output->pedal_cmd = input->pedal_cmd;
  // pedal_cmd_type
  output->pedal_cmd_type = input->pedal_cmd_type;
  // enable
  output->enable = input->enable;
  // clear
  output->clear = input->clear;
  // ignore
  output->ignore = input->ignore;
  // count
  output->count = input->count;
  return true;
}

dataspeed_dbw_msgs__msg__ThrottleCmd *
dataspeed_dbw_msgs__msg__ThrottleCmd__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__ThrottleCmd * msg = (dataspeed_dbw_msgs__msg__ThrottleCmd *)allocator.allocate(sizeof(dataspeed_dbw_msgs__msg__ThrottleCmd), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dataspeed_dbw_msgs__msg__ThrottleCmd));
  bool success = dataspeed_dbw_msgs__msg__ThrottleCmd__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dataspeed_dbw_msgs__msg__ThrottleCmd__destroy(dataspeed_dbw_msgs__msg__ThrottleCmd * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dataspeed_dbw_msgs__msg__ThrottleCmd__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__init(dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__ThrottleCmd * data = NULL;

  if (size) {
    data = (dataspeed_dbw_msgs__msg__ThrottleCmd *)allocator.zero_allocate(size, sizeof(dataspeed_dbw_msgs__msg__ThrottleCmd), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dataspeed_dbw_msgs__msg__ThrottleCmd__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dataspeed_dbw_msgs__msg__ThrottleCmd__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__fini(dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dataspeed_dbw_msgs__msg__ThrottleCmd__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence *
dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * array = (dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence *)allocator.allocate(sizeof(dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__destroy(dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__are_equal(const dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * lhs, const dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dataspeed_dbw_msgs__msg__ThrottleCmd__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence__copy(
  const dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * input,
  dataspeed_dbw_msgs__msg__ThrottleCmd__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dataspeed_dbw_msgs__msg__ThrottleCmd);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dataspeed_dbw_msgs__msg__ThrottleCmd * data =
      (dataspeed_dbw_msgs__msg__ThrottleCmd *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dataspeed_dbw_msgs__msg__ThrottleCmd__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dataspeed_dbw_msgs__msg__ThrottleCmd__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dataspeed_dbw_msgs__msg__ThrottleCmd__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
